#include <unistd.h>
#include <syscall.h>
#include <gnu-stabs.h>

extern void		__ieee_set_fp_control (unsigned long fpcw);
extern unsigned long	__ieee_get_fp_control (void);

/*
 * We do want to make ieee_set_fp_control() and ieee_get_fp_control()
 * available to the user.  However, the setsysinfo() and getsysinfo()
 * are really ugly and we do not want to encourage anyway to make use
 * of them.  Thus we do the corresponding syscall inline here.
 *
 * In any case, it's probably more portable to use the __setfpucw()
 * call instead.
 */

void
__ieee_set_fp_control (unsigned long fpcw)
{
    /* 14 == SSI_IEEE_FP_CONTROL */
    syscall2(14, (long) &fpcw, SYS_osf_setsysinfo);
}


unsigned long
__ieee_get_fp_control (void)
{
    unsigned long fpcw;

    /* 45 == GSI_IEEE_FP_CONTROL */
    syscall2(45, (long) &fpcw, SYS_osf_getsysinfo);
    return fpcw;
}

weak_alias(__ieee_get_fp_control, ieee_get_fp_control);
weak_alias(__ieee_set_fp_control, ieee_set_fp_control);
