#define __ASSEMBLY__

#include <alpha/jmp_buf.h>
#include <alpha/regdef.h>

#include <asm/pal.h>

/* Store the calling environment in ENV.  Return when first
 * called.  Return a nonzero value when we longjmp back to
 * this point.
 *
 * Usage: 
 *	retval = __setjmp(jmp_buf * buf)
 */


	.globl	__setjmp
	.ent	__setjmp
__setjmp:
	.frame	sp,0,ra,0
	.prologue 0

	stq     t0,JB_T0*8(a0)
	stq     t1,JB_T1*8(a0)
	stq     t2,JB_T2*8(a0)
	stq     t3,JB_T3*8(a0)
	stq     t4,JB_T4*8(a0)
	stq     t5,JB_T5*8(a0)
	stq     t6,JB_T6*8(a0)
	stq     t7,JB_T7*8(a0)
	stq     s0,JB_S0*8(a0)
	stq     s1,JB_S1*8(a0)
	stq     s2,JB_S2*8(a0)
	stq     s3,JB_S3*8(a0)
	stq     s4,JB_S4*8(a0)
	stq     s5,JB_S5*8(a0)
	stq     fp,JB_S6*8(a0)
	stq     a0,JB_A0*8(a0)
	stq     a1,JB_A1*8(a0)
	stq     a2,JB_A2*8(a0)
	stq     a3,JB_A3*8(a0)
	stq     a4,JB_A4*8(a0)
	stq     a5,JB_A5*8(a0)
	stq     t8,JB_T8*8(a0)
	stq     t9,JB_T9*8(a0)
	stq     t10,JB_T10*8(a0)
	stq     t11,JB_T11*8(a0)
	stq     ra,JB_RA*8(a0)
	stq     pv,JB_PV*8(a0)
	stq     AT,JB_AT*8(a0)
	stq     gp,JB_GP*8(a0)
	lda	t0,(JBMAGIC & 0xffff)(zero)
	ldah	t0,(JBMAGIC >> 16)(t0)
	stq     sp,JB_SP*8(a0)
	stq	t0,JB_MAGIC*8(a0)

	stt     $f0,JB_F0*8(a0)		# Floating regs...
	stt     $f1,JB_F1*8(a0)
	stt     $f2,JB_F2*8(a0)
	stt     $f3,JB_F3*8(a0)
	stt     $f4,JB_F4*8(a0)
	stt     $f5,JB_F5*8(a0)
	stt     $f6,JB_F6*8(a0)
	stt     $f7,JB_F7*8(a0)
	stt     $f8,JB_F8*8(a0)
	stt     $f9,JB_F9*8(a0)
	stt     $f10,JB_F10*8(a0)
	stt     $f11,JB_F11*8(a0)
	stt     $f12,JB_F12*8(a0)
	stt     $f13,JB_F13*8(a0)
	stt     $f14,JB_F14*8(a0)
	stt     $f15,JB_F15*8(a0)
	stt     $f16,JB_F16*8(a0)
	stt     $f17,JB_F17*8(a0)
	stt     $f18,JB_F18*8(a0)
	stt     $f19,JB_F19*8(a0)
	stt     $f20,JB_F20*8(a0)
	stt     $f21,JB_F21*8(a0)
	stt     $f22,JB_F22*8(a0)
	stt     $f23,JB_F23*8(a0)
	stt     $f24,JB_F24*8(a0)
	stt     $f25,JB_F25*8(a0)
	stt     $f26,JB_F26*8(a0)
	stt     $f27,JB_F27*8(a0)
	stt     $f28,JB_F28*8(a0)
	stt     $f29,JB_F29*8(a0)
	ldil	t0,8
	stt     $f30,JB_F30*8(a0)
	stq	t0,JB_PS*8(a0)		/* PS - Must be 8 in user mode! */
	bis	zero,zero,v0		/* Set return value to 0 */
	br	t0,1f
1:	stq	t0,JB_PC*8(a0)		/* <- come back point on __longjmp */
	ret	zero,(ra)
	.end	__setjmp
