/*
 * Copyright (C) 1991, 1992, 1993, 1994 Free Software Foundation, Inc.
 *
 * This file is part of the GNU C Library.
 *
 * The GNU C Library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public License
 * as published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * The GNU C Library is distributed in the hope that it will be
 * useful, but WITHOUT ANY WARRANTY; without even the implied warranty
 * of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with the GNU C Library; see the file COPYING.LIB.  If
 * not, write to the, 1992 Free Software Foundation, Inc., 675 Mass
 * Ave, Cambridge, MA 02139, USA.
 */
#ifndef _ALPHA_JMP_BUF_H
#define _ALPHA_JMP_BUF_H

#if !defined(_POSIX_SOURCE) && !defined(_XOPEN_SOURCE)

#define JB_ONSIGSTK	0		/* onsigstack flag */
#define JB_SIGMASK	1		/* signal mask */
#define JB_PC		2		/* program counter */
#define JB_PS		3		/* processor status */
#define JB_REGS		4		/* registers */
#define JB_V0		(JB_REGS+0)
#define JB_T0		(JB_REGS+1)
#define JB_T1		(JB_REGS+2)
#define JB_T2		(JB_REGS+3)
#define JB_T3		(JB_REGS+4)
#define JB_T4		(JB_REGS+5)
#define JB_T5		(JB_REGS+6)
#define JB_T6		(JB_REGS+7)
#define JB_T7		(JB_REGS+8)
#define JB_S0		(JB_REGS+9)
#define JB_S1		(JB_REGS+10)
#define JB_S2		(JB_REGS+11)
#define JB_S3		(JB_REGS+12)
#define JB_S4		(JB_REGS+13)
#define JB_S5		(JB_REGS+14)
#define JB_S6		(JB_REGS+15)
#define JB_A0		(JB_REGS+16)
#define JB_A1		(JB_REGS+17)
#define JB_A2		(JB_REGS+18)
#define JB_A3		(JB_REGS+19)
#define JB_A4		(JB_REGS+20)
#define JB_A5		(JB_REGS+21)
#define JB_T8		(JB_REGS+22)
#define JB_T9		(JB_REGS+23)
#define JB_T10		(JB_REGS+24)
#define JB_T11		(JB_REGS+25)
#define JB_RA		(JB_REGS+26)
#define JB_PV		(JB_REGS+27)
#define JB_AT		(JB_REGS+28)
#define JB_GP		(JB_REGS+29)
#define JB_SP		(JB_REGS+30)
#define JB_ZERO		(JB_REGS+31)
#define JB_MAGIC	JB_ZERO		/* use zero-reg slot to store magic */

#define JB_FREGS	37
#define JB_F0		(JB_FREGS+0)
#define JB_F1		(JB_FREGS+1)
#define JB_F2		(JB_FREGS+2)
#define JB_F3		(JB_FREGS+3)
#define JB_F4		(JB_FREGS+4)
#define JB_F5		(JB_FREGS+5)
#define JB_F6		(JB_FREGS+6)
#define JB_F7		(JB_FREGS+7)
#define JB_F8		(JB_FREGS+8)
#define JB_F9		(JB_FREGS+9)
#define JB_F10		(JB_FREGS+10)
#define JB_F11		(JB_FREGS+11)
#define JB_F12		(JB_FREGS+12)
#define JB_F13		(JB_FREGS+13)
#define JB_F14		(JB_FREGS+14)
#define JB_F15		(JB_FREGS+15)
#define JB_F16		(JB_FREGS+16)
#define JB_F17		(JB_FREGS+17)
#define JB_F18		(JB_FREGS+18)
#define JB_F19		(JB_FREGS+19)
#define JB_F20		(JB_FREGS+20)
#define JB_F21		(JB_FREGS+21)
#define JB_F22		(JB_FREGS+22)
#define JB_F23		(JB_FREGS+23)
#define JB_F24		(JB_FREGS+24)
#define JB_F25		(JB_FREGS+25)
#define JB_F26		(JB_FREGS+26)
#define JB_F27		(JB_FREGS+27)
#define JB_F28		(JB_FREGS+28)
#define JB_F29		(JB_FREGS+29)
#define JB_F30		(JB_FREGS+30)
#define JB_F31		(JB_FREGS+31)

#define JB_FLAGS	JB_F31		/* flags: 1 => restore signal mask */

#define JBMAGIC		0xacedbade

/*
 * Mostly for OSF/1 compatibility:
 */
#define JB_SSIZE	81
#define JB_SBASE	82

#define SIGCONTEXT_PAD	48
#define NJBREGS		(JB_ZERO+1+SIGCONTEXT_PAD)

#endif /* !defined(_POSIX_SOURCE) && !defined(_XOPEN_SOURCE) */


#define _JBLEN	84	/* must match NJBREGS */

#ifndef __ASSEMBLY__

typedef long	__jmp_buf[_JBLEN];
typedef long	__sigjmp_buf[_JBLEN];

#endif /* __ASSEMBLY__ */

#endif /* _ALPHA_JMP_BUF_H */
